import es
import playerlib
import usermsg
import gamethread

from rankme import rankme

addonName = "spectarget"

spectarget = rankme.addons.registerAddon(addonName)

class Player(object):
    
    def __init__(self, userid):
        self.userid = userid
        self.target = None
        
    def update(self):
        """
        Update the player's message showing his targets ranks.
        """
        if not es.exists('userid', self.userid):
            return
        
        if es.getplayerteam(self.userid) in (2, 3):
            if not playerlib.getPlayer(self.userid).isdead:
                return
        
        target = self.getspec()
        if target != -1:
            self.target = target
            
            player = rankme.getPlayer(self.target)
            uniqueid = player.uniqueid
            if player.rank == None:
                return
            
            session = rankme.database.getSessionData(uniqueid)
            name = es.getplayername(self.target)
            kdr = rankme.convertKdr(session['kills'], session['deaths'])
            position = rankme.database.getPosition(uniqueid)
            points = rankme.database.getPoints(uniqueid)
            gain = '+%s' % session['points'] if session['points'] > -1 else '%s' % session['points']
            headshots = session['headshots']
            hpk = rankme.convertKdr(session['headshots'], session['kills'])
            timeplayed = rankme.GetInHMS(int(session['timeplayed']))
            
            es.usermsg('create', 'target_%s' % self.userid, 'KeyHintText')
            es.usermsg('write', 'byte', 'target_%s' % self.userid, 1)
            es.usermsg('write', 'string', 'target_%s' % self.userid, "%s\nPosition %s of %s \n%s (%s) Points\n%s : %s (%s) Frags\n%s (%s) Headshots\n%s" % (name, position, rankme.database.getTotalCount(), rankme.getFormat(points), gain, session['kills'], session['deaths'], kdr, headshots, hpk, timeplayed))
            es.usermsg('send', 'target_%s' % self.userid, self.userid)
            es.usermsg('delete', 'target_%s' % self.userid)
            
            
    def hide(self):
        """
        Hides the hint box during game play.
        """
        gamethread.cancelDelayed('spectarget_loop_%s' % self.userid)
        
    def getspec(self):
        """
        Gets the handle of the player that the user is spectating.
        """
        handle = es.getplayerprop(self.userid, "CCSPlayer.baseclass.m_hObserverTarget")
        for tuserid in es.getUseridList():
            thandle = es.getplayerhandle(tuserid)
            if thandle == handle:
                return tuserid

        return -1

players = {}
def getPlayer(userid):
    userid = int(userid)
    if userid not in players:
        players[userid] = Player(userid)
        
    return players[userid]
    
def unload():
    """
    Fires when the script is unloaded.
    """
    gamethread.cancelDelayed('spectarget_loop')

def es_map_start(ev):
    """
    Executed when the map is loaded on the server.
    """
    gamethread.cancelDelayed('spectarget_loop')
    loop()
    
def loop():
    for userid in es.getUseridList():
        getPlayer(userid).update()
        
    gamethread.delayedname(0.1, 'spectarget_loop', loop)
    